open Transition
open Letters
open Tree
open Status
(*
let print_action = function
  | BO -> print_string "<B>"
  | BC -> print_string "</B>"
  | EMO -> print_string "<EM>"
  | EMC -> print_string "</EM>"
  | IO -> print_string "<I>"
  | IC -> print_string "</I>"
  | PLO -> print_string "<PL>"
  | PLC -> print_string "</PL>"
  | SO -> print_string "<S>"
  | SC -> print_string "</S>"
  | TTO -> print_string "<TT>"
  | TTC -> print_string "</TT>"
  | UO -> print_string "<U>"
  | UC -> print_string "</U>"
(* Sizes *)
  | S0O -> print_string "<0>"
  | S0C -> print_string "</0>"
  | S1O -> print_string "<1>"
  | S1C -> print_string "</1>"
  | S2O -> print_string "<2>"
  | S2C -> print_string "</2>"
  | S3O -> print_string "<3>"
  | S3C -> print_string "</3>"
  | S4O -> print_string "<4>"
  | S4C -> print_string "</4>"
  | S5O -> print_string "<5>"
  | S5C -> print_string "</5>"
  | S6O -> print_string "<6>"
  | S6C -> print_string "</6>"
 
 | S7O -> print_string "<7>"
  | S7C -> print_string "</7>"
  | S8O -> print_string "<8>"
  | S8C -> print_string "</8>"
  | S9O -> print_string "<9>"
  | S9C -> print_string "</9>"
(* Colours *)
  | CRO -> print_string "<r>"
  | CRC -> print_string "</r>"
  | CGO -> print_string "<g>"
  | CGC -> print_string "</g>"
  | CBO -> print_string "<b>"
  | CBC -> print_string "</b>"
  | CCO -> print_string "<c>"
  | CCC -> print_string "</c>"
  | CMO -> print_string "<m>"
  | CMC -> print_string "</n>"
  | CYO -> print_string "<y>"
  | CYC -> print_string "</y>"
  | CKO -> print_string "<k>"
  | CKC -> print_string "</k>"
  | CWO -> print_string "<w>"
  | CWC -> print_string "</w>"
  | _ -> print_string "Warning: undefined"
*)
type rest = End | ConsTree of tree * rest | ConsAct of Act.action * rest

let rec print_tree rest = function
  | STR ->
      output_next_letters ();
      print_rest rest
  | (Node (l,s)) ->
      Act.print_open_action l;
      print_tree_list (ConsAct (l,rest)) s

and print_tree_list rest s =
  match Stacklist.decomp s with
    | Stacklist.Zero -> failwith "Should be removed"
    | Stacklist.One s1 -> print_tree rest s1
    | Stacklist.Many ->
	let t = Stacklist.pop s in
	print_tree_list (ConsTree (t,rest)) s

and print_rest = function
  | End -> ()
  | ConsTree (s,rest) -> print_tree rest s
  | ConsAct (l,rest) -> Act.print_close_action l; print_rest rest

let print_document d = 
  restart_letters_table ();
  print_tree_list End d
