type 'a t = { mutable length : int; mutable vect : 'a array }

let maxarraysize = 4000000

let create () = { length = maxarraysize; vect = [||] }

let push x ({ length = n; vect = v } as s) =
  if v = [||] then (s.vect <- Array.create n x; s.length <- 1)
  else (v.(n) <- x; s.length <- n + 1)

let pop s = let n = s.length - 1 in s.length <- n; s.vect.(n)

let top s = s.vect.(s.length - 1)

let iter f { length = n; vect = v } = 
  if v <> [||] then for i=0 to n - 1 do f v.(i) done

type 'a l = Zero | One of 'a | Many

let decomp { length = n; vect = v } = 
  if v = [||] then Zero else 
    match n with 0 -> Zero | 1 -> One v.(0) | _ -> Many
