type tag =
(* Base tags *)
  | BO
  | EMO
  | IO
  | SO
  | TTO
  | UO
  | PLO
(* Sizes *)
  | S0O
  | S1O
  | S2O
  | S3O
  | S4O
  | S5O
  | S6O
  | S7O
  | S8O
  | S9O
(* Colours *)
  | CRO
  | CGO
  | CBO
  | CCO
  | CMO
  | CYO
  | CKO
  | CWO (* = white, used in space_status *)
(* Special code for removing *)
  | REMOVE
(* Special code for initial colors and sizes *)
  | UNDEFINED
(* Special code for a tag removed at parsing time *)
  | NOTAG

let rec remove x = function
  |[] -> raise Not_found
  |y::q when x = y -> q
  |t::q -> t::(remove x q)

let remove_token = remove

type token = Open of tag | Closed of tag | Notag
